Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLab.Clients.OKB-3.3.csproj
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 5072)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/HeuristicLab.Clients.OKB-3.3.csproj	(revision 5073)
@@ -95,4 +95,5 @@
   <ItemGroup>
     <Compile Include="AdministratorMenuItem.cs" />
+    <Compile Include="QueryMenuItem.cs" />
     <Compile Include="OKBClient.cs" />
     <Compile Include="OKBExperiment.cs" />
@@ -170,4 +171,10 @@
       <DependentUpon>AlgorithmParameterView.cs</DependentUpon>
     </Compile>
+    <Compile Include="Views\QueryView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\QueryView.Designer.cs">
+      <DependentUpon>QueryView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\RunView.cs">
       <SubType>UserControl</SubType>
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/OKBClient.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/OKBClient.cs	(revision 5072)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/OKBClient.cs	(revision 5073)
@@ -361,4 +361,13 @@
 
     #region Experiment Methods
+    public Experiment GetExperiment(long id) {
+      try {
+        return CallAdminService<Experiment>(s => s.GetExperiment(id));
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Refresh experiment failed.", ex);
+        return null;
+      }
+    }
     public ItemCollection<Experiment> GetExperiments(long algorithmId, long problemId) {
       try {
@@ -381,4 +390,15 @@
         runs.AddRange(CallAdminService<Run[]>(s => s.GetRuns(experimentId)).OrderByDescending(x => x.FinishedDate));
         runs.ItemsRemoved += new CollectionItemsChangedEventHandler<Run>(runs_ItemsRemoved);
+        return runs;
+      }
+      catch (Exception ex) {
+        ErrorHandling.ShowErrorDialog("Refresh runs failed.", ex);
+        return null;
+      }
+    }
+    public ItemCollection<Run> QueryRuns(string query) {
+      try {
+        ItemCollection<Run> runs = new ItemCollection<Run>();
+        runs.AddRange(CallAdminService<Run[]>(s => s.QueryRuns(query)).OrderByDescending(x => x.FinishedDate));
         return runs;
       }
@@ -593,4 +613,86 @@
       }
     }
+    public RunCollection ConvertOKBRunsToOptimizationRuns(IItemCollection<Run> runs) {
+      RunCollection runCollection = new RunCollection();
+      foreach (Run run in runs) {
+        Optimization.Run r = new Optimization.Run();
+        foreach (ResultValue resultValue in run.ResultValues) {
+          Result result = GetResult(resultValue.ResultId);
+          if (resultValue is ResultBlobValue) {
+            IItem item = null;
+            using (MemoryStream stream = new MemoryStream(((ResultBlobValue)resultValue).Value)) {
+              try {
+                item = XmlParser.Deserialize<IItem>(stream);
+              }
+              catch (Exception ex) {
+                ErrorHandling.ShowErrorDialog(ex);
+              }
+              stream.Close();
+            }
+            r.Results.Add(result.Name, item);
+          } else if (resultValue is ResultBoolValue) {
+            r.Results.Add(result.Name, new BoolValue(((ResultBoolValue)resultValue).Value));
+          } else if (resultValue is ResultFloatValue) {
+            r.Results.Add(result.Name, new DoubleValue(((ResultFloatValue)resultValue).Value));
+          } else if (resultValue is ResultIntValue) {
+            r.Results.Add(result.Name, new IntValue((int)((ResultIntValue)resultValue).Value));
+          } else if (resultValue is ResultStringValue) {
+            r.Results.Add(result.Name, new StringValue(((ResultStringValue)resultValue).Value));
+          }
+        }
+
+        Experiment exp = GetExperiment(run.ExperimentId);
+        foreach (AlgorithmParameterValue algorithmParameterValue in exp.AlgorithmParameterValues) {
+          AlgorithmParameter algorithmParameter = GetAlgorithmParameter(algorithmParameterValue.AlgorithmParameterId);
+          if (algorithmParameterValue is AlgorithmParameterBlobValue) {
+            IItem item = null;
+            using (MemoryStream stream = new MemoryStream(((AlgorithmParameterBlobValue)algorithmParameterValue).Value)) {
+              try {
+                item = XmlParser.Deserialize<IItem>(stream);
+              }
+              catch (Exception ex) {
+                ErrorHandling.ShowErrorDialog(ex);
+              }
+              stream.Close();
+            }
+            r.Parameters.Add(algorithmParameter.Name, item);
+          } else if (algorithmParameterValue is AlgorithmParameterBoolValue) {
+            r.Parameters.Add(algorithmParameter.Name, new BoolValue(((AlgorithmParameterBoolValue)algorithmParameterValue).Value));
+          } else if (algorithmParameterValue is AlgorithmParameterFloatValue) {
+            r.Parameters.Add(algorithmParameter.Name, new DoubleValue(((AlgorithmParameterFloatValue)algorithmParameterValue).Value));
+          } else if (algorithmParameterValue is AlgorithmParameterIntValue) {
+            r.Parameters.Add(algorithmParameter.Name, new IntValue((int)((AlgorithmParameterIntValue)algorithmParameterValue).Value));
+          } else if (algorithmParameterValue is AlgorithmParameterStringValue) {
+            r.Parameters.Add(algorithmParameter.Name, new StringValue(((AlgorithmParameterStringValue)algorithmParameterValue).Value));
+          }
+        }
+        foreach (ProblemParameterValue problemParameterValue in exp.ProblemParameterValues) {
+          ProblemParameter problemParameter = GetProblemParameter(problemParameterValue.ProblemParameterId);
+          if (problemParameterValue is ProblemParameterBlobValue) {
+            IItem item = null;
+            using (MemoryStream stream = new MemoryStream(((ProblemParameterBlobValue)problemParameterValue).Value)) {
+              try {
+                item = XmlParser.Deserialize<IItem>(stream);
+              }
+              catch (Exception ex) {
+                ErrorHandling.ShowErrorDialog(ex);
+              }
+              stream.Close();
+            }
+            r.Parameters.Add(problemParameter.Name, item);
+          } else if (problemParameterValue is ProblemParameterBoolValue) {
+            r.Parameters.Add(problemParameter.Name, new BoolValue(((ProblemParameterBoolValue)problemParameterValue).Value));
+          } else if (problemParameterValue is ProblemParameterFloatValue) {
+            r.Parameters.Add(problemParameter.Name, new DoubleValue(((ProblemParameterFloatValue)problemParameterValue).Value));
+          } else if (problemParameterValue is ProblemParameterIntValue) {
+            r.Parameters.Add(problemParameter.Name, new IntValue((int)((ProblemParameterIntValue)problemParameterValue).Value));
+          } else if (problemParameterValue is ProblemParameterStringValue) {
+            r.Parameters.Add(problemParameter.Name, new StringValue(((ProblemParameterStringValue)problemParameterValue).Value));
+          }
+        }
+        runCollection.Add(r);
+      }
+      return runCollection;
+    }
     #endregion
 
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/QueryMenuItem.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/QueryMenuItem.cs	(revision 5073)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/QueryMenuItem.cs	(revision 5073)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Optimizer;
+
+namespace HeuristicLab.Clients.OKB {
+  internal class QueryMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
+    public override string Name {
+      get { return "&Query"; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&Services", "&OKB" }; }
+    }
+    public override int Position {
+      get { return 4220; }
+    }
+
+    public override void Execute() {
+      QueryView view = new QueryView();
+      view.Content = OKBClient.Instance;
+      view.Show();
+    }
+  }
+}
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/QueryView.Designer.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/QueryView.Designer.cs	(revision 5073)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/QueryView.Designer.cs	(revision 5073)
@@ -0,0 +1,123 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Clients.OKB {
+  partial class QueryView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(QueryView));
+      this.refreshButton = new System.Windows.Forms.Button();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.runCollectionView = new HeuristicLab.Clients.OKB.RunCollectionView();
+      this.showRunsButton = new System.Windows.Forms.Button();
+      this.queryTextBox = new System.Windows.Forms.TextBox();
+      this.SuspendLayout();
+      // 
+      // refreshButton
+      // 
+      this.refreshButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Refresh;
+      this.refreshButton.Location = new System.Drawing.Point(0, 0);
+      this.refreshButton.Name = "refreshButton";
+      this.refreshButton.Size = new System.Drawing.Size(24, 24);
+      this.refreshButton.TabIndex = 0;
+      this.toolTip.SetToolTip(this.refreshButton, "Refresh Data");
+      this.refreshButton.UseVisualStyleBackColor = true;
+      this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
+      // 
+      // runCollectionView
+      // 
+      this.runCollectionView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.runCollectionView.Caption = "RunCollection View";
+      this.runCollectionView.Content = null;
+      this.runCollectionView.Location = new System.Drawing.Point(0, 30);
+      this.runCollectionView.Name = "runCollectionView";
+      this.runCollectionView.ReadOnly = false;
+      this.runCollectionView.Size = new System.Drawing.Size(727, 405);
+      this.runCollectionView.TabIndex = 3;
+      // 
+      // showRunsButton
+      // 
+      this.showRunsButton.Location = new System.Drawing.Point(30, 0);
+      this.showRunsButton.Name = "showRunsButton";
+      this.showRunsButton.Size = new System.Drawing.Size(75, 24);
+      this.showRunsButton.TabIndex = 1;
+      this.showRunsButton.Text = "&Show Runs";
+      this.showRunsButton.UseVisualStyleBackColor = true;
+      this.showRunsButton.Click += new System.EventHandler(this.showRunsButton_Click);
+      // 
+      // queryTextBox
+      // 
+      this.queryTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.queryTextBox.Location = new System.Drawing.Point(111, 3);
+      this.queryTextBox.Name = "queryTextBox";
+      this.queryTextBox.Size = new System.Drawing.Size(616, 20);
+      this.queryTextBox.TabIndex = 2;
+      // 
+      // QueryView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.queryTextBox);
+      this.Controls.Add(this.showRunsButton);
+      this.Controls.Add(this.runCollectionView);
+      this.Controls.Add(this.refreshButton);
+      this.Name = "QueryView";
+      this.Size = new System.Drawing.Size(727, 435);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button refreshButton;
+    private System.Windows.Forms.ToolTip toolTip;
+    private RunCollectionView runCollectionView;
+    private System.Windows.Forms.Button showRunsButton;
+    private System.Windows.Forms.TextBox queryTextBox;
+
+  }
+}
Index: /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/QueryView.cs
===================================================================
--- /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/QueryView.cs	(revision 5073)
+++ /branches/OKB/HeuristicLab.Clients.OKB-3.3/Views/QueryView.cs	(revision 5073)
@@ -0,0 +1,74 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+
+namespace HeuristicLab.Clients.OKB {
+  [View("OKB Administrator")]
+  [Content(typeof(OKBClient), false)]
+  public sealed partial class QueryView : AsynchronousContentView {
+    public new OKBClient Content {
+      get { return (OKBClient)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public QueryView() {
+      InitializeComponent();
+    }
+
+    protected override void DeregisterContentEvents() {
+      // ...
+      base.DeregisterContentEvents();
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      // ...
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        // ...
+      } else {
+        // ...
+      }
+      runCollectionView.Content = null;
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      refreshButton.Enabled = Content != null;
+      runCollectionView.Enabled = Content != null;
+    }
+
+    private void refreshButton_Click(object sender, EventArgs e) {
+      runCollectionView.Content = Content.QueryRuns(queryTextBox.Text);
+    }
+
+    private void showRunsButton_Click(object sender, EventArgs e) {
+      MainFormManager.MainForm.ShowContent(OKBClient.Instance.ConvertOKBRunsToOptimizationRuns(runCollectionView.Content));
+    }
+  }
+}
Index: /branches/OKB/HeuristicLab.Services.OKB/3.3/Interfaces/IOKBService.cs
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB/3.3/Interfaces/IOKBService.cs	(revision 5072)
+++ /branches/OKB/HeuristicLab.Services.OKB/3.3/Interfaces/IOKBService.cs	(revision 5073)
@@ -188,4 +188,6 @@
     IEnumerable<Run> GetRuns(long experimentId);
     [OperationContract]
+    IEnumerable<Run> QueryRuns(string query);
+    [OperationContract]
     long AddRun(Run dto);
     [OperationContract]
Index: /branches/OKB/HeuristicLab.Services.OKB/3.3/OKBService.cs
===================================================================
--- /branches/OKB/HeuristicLab.Services.OKB/3.3/OKBService.cs	(revision 5072)
+++ /branches/OKB/HeuristicLab.Services.OKB/3.3/OKBService.cs	(revision 5073)
@@ -534,4 +534,70 @@
       }
     }
+    public IEnumerable<DataTransfer.Run> QueryRuns(string query) {
+      using (OKBDataContext okb = new OKBDataContext()) {
+        DataLoadOptions dlo = new DataLoadOptions();
+        dlo.LoadWith<Run>(x => x.ResultBlobValues);
+        dlo.LoadWith<Run>(x => x.ResultBoolValues);
+        dlo.LoadWith<Run>(x => x.ResultFloatValues);
+        dlo.LoadWith<Run>(x => x.ResultIntValues);
+        dlo.LoadWith<Run>(x => x.ResultStringValues);
+        dlo.LoadWith<Run>(x => x.Experiment);
+        dlo.LoadWith<ResultBlobValue>(x => x.Result);
+        dlo.LoadWith<ResultBlobValue>(x => x.DataType);
+        dlo.LoadWith<ResultBoolValue>(x => x.Result);
+        dlo.LoadWith<ResultBoolValue>(x => x.DataType);
+        dlo.LoadWith<ResultFloatValue>(x => x.Result);
+        dlo.LoadWith<ResultFloatValue>(x => x.DataType);
+        dlo.LoadWith<ResultIntValue>(x => x.Result);
+        dlo.LoadWith<ResultIntValue>(x => x.DataType);
+        dlo.LoadWith<ResultStringValue>(x => x.Result);
+        dlo.LoadWith<ResultStringValue>(x => x.DataType);
+        dlo.LoadWith<Result>(x => x.Algorithm);
+        dlo.LoadWith<Result>(x => x.DataType);
+        dlo.LoadWith<Experiment>(x => x.Algorithm);
+        dlo.LoadWith<Experiment>(x => x.Problem);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterBlobValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterBoolValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterFloatValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterIntValues);
+        dlo.LoadWith<Experiment>(x => x.AlgorithmParameterStringValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterBlobValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterBoolValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterFloatValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterIntValues);
+        dlo.LoadWith<Experiment>(x => x.ProblemParameterStringValues);
+        dlo.LoadWith<AlgorithmParameterBlobValue>(x => x.AlgorithmParameter);
+        dlo.LoadWith<AlgorithmParameterBlobValue>(x => x.DataType);
+        dlo.LoadWith<AlgorithmParameterBoolValue>(x => x.AlgorithmParameter);
+        dlo.LoadWith<AlgorithmParameterBoolValue>(x => x.DataType);
+        dlo.LoadWith<AlgorithmParameterFloatValue>(x => x.AlgorithmParameter);
+        dlo.LoadWith<AlgorithmParameterFloatValue>(x => x.DataType);
+        dlo.LoadWith<AlgorithmParameterIntValue>(x => x.AlgorithmParameter);
+        dlo.LoadWith<AlgorithmParameterIntValue>(x => x.DataType);
+        dlo.LoadWith<AlgorithmParameterStringValue>(x => x.AlgorithmParameter);
+        dlo.LoadWith<AlgorithmParameterStringValue>(x => x.DataType);
+        dlo.LoadWith<ProblemParameterBlobValue>(x => x.ProblemParameter);
+        dlo.LoadWith<ProblemParameterBlobValue>(x => x.DataType);
+        dlo.LoadWith<ProblemParameterBoolValue>(x => x.ProblemParameter);
+        dlo.LoadWith<ProblemParameterBoolValue>(x => x.DataType);
+        dlo.LoadWith<ProblemParameterFloatValue>(x => x.ProblemParameter);
+        dlo.LoadWith<ProblemParameterFloatValue>(x => x.DataType);
+        dlo.LoadWith<ProblemParameterIntValue>(x => x.ProblemParameter);
+        dlo.LoadWith<ProblemParameterIntValue>(x => x.DataType);
+        dlo.LoadWith<ProblemParameterStringValue>(x => x.ProblemParameter);
+        dlo.LoadWith<ProblemParameterStringValue>(x => x.DataType);
+        dlo.LoadWith<AlgorithmParameter>(x => x.Algorithm);
+        dlo.LoadWith<AlgorithmParameter>(x => x.DataType);
+        dlo.LoadWith<ProblemParameter>(x => x.Problem);
+        dlo.LoadWith<ProblemParameter>(x => x.DataType);
+        dlo.LoadWith<Algorithm>(x => x.AlgorithmClass);
+        dlo.LoadWith<Algorithm>(x => x.Platform);
+        dlo.LoadWith<Problem>(x => x.ProblemClass);
+        dlo.LoadWith<Problem>(x => x.Platform);
+        okb.LoadOptions = dlo;
+        var runs = okb.Runs.Where(x => x.ResultFloatValues.Any(y => y.Result.Name == "BestQuality" && y.Value > double.Parse(query)));
+        return runs.Select(x => Convert.ToDto(x)).ToArray();
+      }
+    }
     public long AddRun(DataTransfer.Run dto) {
       using (OKBDataContext okb = new OKBDataContext()) {
